var T_FILE = "zxnz_core_fs_File";
var T_FOLDER = "zxnz_core_fs_Folder";
var node_fs = require('fs');
module.exports = zn.Controller('download', {
    methods: {
        file: {
            method: 'GET/POST',
            route: '/file/:tempName',
            argv: {
                tempName: null
            },
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName'),
                    _downloadName = request.getValue('downloadName');
                zxnz.store.beginPoolTransaction()
                    .query("select configs by namespace", function (){
                        return zxnz.sql.select({
                            table: T_FILE,
                            where: {
                                zxnz_core_fs_file_Temp_Name: _tempName
                            }
                        });
                    })
                    .commit()
                    .then(function (data){
                        if(!data.length){
                            return response.error('文件不存在！'), false;
                        }else{
                            var _file = data[0];
                            if(!node_fs.existsSync(_file.zxnz_core_fs_file_Saved_Path)){
                                return response.error('文件已经被删除, 请联系管理员'), false;
                            }
                            var _serverResponse = response._serverResponse,
                                _fileStat = node_fs.statSync(_file.zxnz_core_fs_file_Saved_Path);
                            if(!_fileStat.isFile()){
                                return response.error('该请求文件路径出错, 请联系管理员'), false;
                            }
                            _serverResponse.writeHead(200, {
                                "Content-Type": _file.zxnz_core_fs_file_Type,
                                "Content-Length": _fileStat.size,
                                "Content-Disposition": "attachment; filename=" + encodeURI(_downloadName || _file.zxnz_core_fs_file_Name)
                            });
                            node_fs.createReadStream(_file.zxnz_core_fs_file_Saved_Path).pipe(_serverResponse);
                        }
                    }, function (err){
                        response.error(err);
                    });
            }
        },
        downloadZipByFolder: {
            method: 'GET/POST',
            argv: {
                folder: null
            },
            value: function (request, response, application, context, router){
                var _namespace = request.getValue('Namespace');
                zxnz.store.beginTransaction()
                    .query("select configs by namespace", function (){
                        return application.resolveModel('Constant').getSelectSql({
                            where: {
                                zxnz_constant_Namespace: _namespace
                            }
                        });
                    }, function (err, data){
                        if(err){
                            response.error(err);
                        }else {
                            response.success(data);
                        }
                    })
                    .commit();
            }
        }
    }
});