var T_FILE = "zxnz_core_fs_File";
var T_FOLDER = "zxnz_core_fs_Folder";
var node_fs = require('fs');
//var node_canvas = require('canvas');
module.exports = zn.Controller('fetch', {
    methods: {
        image: {
            method: 'GET/POST',
            route: '/image/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                zxnz.store.beginPoolTransaction()
                    .query("Select file by tempName: ", function (){
                        return zxnz.sql.select({
                            table: T_FILE,
                            where: {
                                zxnz_core_fs_file_Temp_Name: _tempName
                            }
                        });
                    })
                    .commit()
                    .then(function (data){
                        if(!data.length){
                            return response.error('文件不存在！'), false;
                        }else{
                            var _file = data[0];
                            if(!node_fs.existsSync(_file.zxnz_core_fs_file_Saved_Path)){
                                return response.error('文件已经被删除, 请联系管理员'), false;
                            }
                            var _fileStat = node_fs.statSync(_file.zxnz_core_fs_file_Saved_Path);
                            if(!_fileStat.isFile()){
                                return response.error('该请求文件路径出错, 请联系管理员'), false;
                            }
                            if(_file.zxnz_core_fs_file_Type.indexOf('image') != 0){
                                return response.error('该请求不是图片类型，请求出错'), false;
                            }
                            _file.zxnz_core_fs_file_Encoding = 'binary';
                            var _serverResponse = response._serverResponse;
                            var _content = node_fs.readFileSync(_file.zxnz_core_fs_file_Saved_Path, {
                                encoding: _file.zxnz_core_fs_file_Encoding,
                                flag: 'r'
                            });

                            context.initHttpHeaderCommonSetting(request._clientRequest, _serverResponse);
                            _serverResponse.setHeader('Content-Type', _file.zxnz_core_fs_file_Type + ";charset=" + _file.zxnz_core_fs_file_Encoding);
                            _serverResponse.setHeader('Content-Length', Buffer.byteLength(_content, _file.zxnz_core_fs_file_Encoding));
                            _serverResponse.writeHead(200, "OK");
                            _serverResponse.end(_content, _file.zxnz_core_fs_file_Encoding);
                        }
                    }, function (err){
                        response.error(err);
                    });
            }
        },
        file: {
            method: 'GET/POST',
            route: '/file/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                zxnz.store.beginPoolTransaction()
                    .query("Select file by tempName: ", function (){
                        return zxnz.sql.select({
                            table: T_FILE,
                            where: {
                                zxnz_core_fs_file_Temp_Name: _tempName
                            }
                        });
                    })
                    .commit()
                    .then(function (data){
                        if(!data.length){
                            return response.error('文件不存在！'), false;
                        }else{
                            var _file = data[0];
                            if(!node_fs.existsSync(_file.zxnz_core_fs_file_Saved_Path)){
                                return response.error('文件已经被删除, 请联系管理员'), false;
                            }
                            var _fileStat = node_fs.statSync(_file.zxnz_core_fs_file_Saved_Path);
                            if(!_fileStat.isFile()){
                                return response.error('该请求文件路径出错, 请联系管理员'), false;
                            }
                            response.success({
                                encoding: _file.zxnz_core_fs_file_Encoding,
                                ext: _file.zxnz_core_fs_file_Ext,
                                lastModifiedDate: _file.zxnz_Inserted_Time,
                                name: _file.zxnz_core_fs_file_Name,
                                path: _file.zxnz_core_fs_file_Path,
                                savedName: _file.zxnz_core_fs_file_Saved_Name,
                                size: _file.zxnz_core_fs_file_Size,
                                tempName: _file.zxnz_core_fs_file_Temp_Name,
                                type: _file.zxnz_core_fs_file_Type
                            });
                        }
                    }, function (err){
                        response.error(err);
                    });
            }
        },
        files: {
            method: 'GET/POST',
            route: '/files/:tempNames',
            value: function (request, response, application, context, router){
                var _tempNames = request.getValue('tempNames');
                zxnz.store.beginPoolTransaction()
                    .query("Select file by tempNames: ", function (){
                        return zxnz.sql.select({
                            table: T_FILE,
                            where: "locate(concat(',', zxnz_core_fs_file_Temp_Name, ','), ',{0},')<>0".format(_tempNames)
                        });
                    })
                    .commit()
                    .then(function (data){
                        var _files = data,
                            _data = [];
                        for(var _file of _files){
                            if(!node_fs.existsSync(_file.zxnz_core_fs_file_Saved_Path)){
                                return response.error('文件已经被删除, 请联系管理员'), false;
                            }
                            var _fileStat = node_fs.statSync(_file.zxnz_core_fs_file_Saved_Path);
                            if(!_fileStat.isFile()){
                                return response.error('该请求文件路径出错, 请联系管理员'), false;
                            }
                            _data.push({
                                encoding: _file.zxnz_core_fs_file_Encoding,
                                ext: _file.zxnz_core_fs_file_Ext,
                                lastModifiedDate: _file.zxnz_Inserted_Time,
                                name: _file.zxnz_core_fs_file_Name,
                                path: _file.zxnz_core_fs_file_Path,
                                savedName: _file.zxnz_core_fs_file_Saved_Name,
                                size: _file.zxnz_core_fs_file_Size,
                                tempName: _file.zxnz_core_fs_file_Temp_Name,
                                type: _file.zxnz_core_fs_file_Type
                            });
                        }

                        response.success(_data);
                    }, function (err){
                        response.error(err);
                    });
            }
        }
    }
});