var T_FILE = "zxnz_core_fs_File";
var T_FOLDER = "zxnz_core_fs_Folder";
module.exports = zn.Controller('upload', {
    methods: {
        fileByName: {
            method: 'GET/POST',
            argv: {
                name: null
            },
            value: function (request, response, application, context, router){
                var _options = require.getJSON('options'),
                    _file = request.uploadFile(request.getValue('name'), _options),
                    _transaction = zxnz.store.beginPoolTransaction();

                _transaction.query(zxnz.sql.insert({
                    table: T_FILE,
                    values: {
                        zxnz_UUID: zn.uuid(),
                        zxnz_core_fs_file_Name: _file.name,
                        zxnz_core_fs_file_Type: _file.type,
                        zxnz_core_fs_file_Temp_Name: _file.tempName,
                        zxnz_core_fs_file_Encoding: _file.encoding,
                        zxnz_core_fs_file_Ext: _file.ext,
                        zxnz_core_fs_file_Saved_Name: _file.savedName,
                        zxnz_core_fs_file_Saved_Dir: _file.savedDir,
                        zxnz_core_fs_file_Saved_Path: _file.savedPath,
                        zxnz_core_fs_file_Path: _file.path,
                        zxnz_core_fs_file_Size: _file.size,
                        fs_Folder: _options.folder,
                        fs_Prefix: _options.prefix,
                        fs_Suffix: _options.suffix
                    }
                }));
                
                _transaction.commit().then(function (){
                    delete _file.savedPath;
                    delete _file.savedDir;
                    response.success(_file);
                }, function (err){
                    response.error(err);
                });
            }
        },
        files: {
            method: 'GET/POST',
            value: function (request, response, application, context, router){
                var _options = request.getValue(),
                    _transaction = zxnz.store.beginPoolTransaction();
                var _files = request.uploadFiles(_options, function (file){
                    _transaction.query(zxnz.sql.insert({
                        table: T_FILE,
                        values: {
                            zxnz_UUID: zn.uuid(),
                            zxnz_core_fs_file_Name: file.name,
                            zxnz_core_fs_file_Type: file.type,
                            zxnz_core_fs_file_Temp_Name: file.tempName,
                            zxnz_core_fs_file_Encoding: file.encoding,
                            zxnz_core_fs_file_Ext: file.ext,
                            zxnz_core_fs_file_Saved_Name: file.savedName,
                            zxnz_core_fs_file_Saved_Dir: file.savedDir,
                            zxnz_core_fs_file_Saved_Path: file.savedPath,
                            zxnz_core_fs_file_Path: file.path,
                            zxnz_core_fs_file_Size: file.size,
                            fs_Name: _options.name,
                            fs_Folder: _options.folder,
                            fs_Prefix: _options.prefix,
                            fs_Suffix: _options.suffix
                        }
                    }));

                    context.jsonWriter.setKeyValue(file.tempName, file.savedPath);
                    delete file.savedPath;
                    delete file.savedDir;

                    return file;
                });
                _transaction.commit().then(function (){
                    response.success(_files);
                }, function (err){
                    response.error(err);
                });
            }
        }
    }
});