"use strict";

var React = znui.React || require('react');

var table = require('znui-react-table');

var button = require('znui-react-button');

var layout = require('znui-react-layout');

var input = require('znui-react-input');

var form = require('znui-react-form');

var popup = require('znui-react-popup');

var selector = require('znui-react-selector');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    return {
      checkedFields: []
    };
  },
  componentDidMount: function componentDidMount() {},
  __onToolBarClick: function __onToolBarClick() {},
  __createField: function __createField() {
    var _this = this;

    var _dialog = popup.dialog({
      title: 'Create Field',
      closeable: true,
      focus: false,
      content: /*#__PURE__*/React.createElement(form.AjaxForm, {
        data: [{
          name: 'zxnz_Label',
          label: 'Label',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Name',
          label: 'Name',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Type',
          label: 'Type',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Length',
          label: 'Length',
          input: input.Input,
          attrs: {
            type: 'number'
          }
        }, {
          name: 'zxnz_table_Field_Unsigned',
          label: 'Unsigned',
          value: 0,
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Field_Zerofill',
          label: 'Zerofill',
          value: 0,
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Field_Binary',
          label: 'Binary',
          value: 0,
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Field_Allow_Null',
          label: 'Allow_Null',
          value: 0,
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Field_Key',
          label: 'Key',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Default',
          label: 'Default',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Extra',
          label: 'Extra',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Encoding',
          label: 'Encoding',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Collation',
          label: 'Collation',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Comment',
          label: 'Comment',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Order',
          label: 'Order',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Convert',
          label: 'Convert',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Hidden',
          label: 'Hidden',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Repeat_Verify',
          label: 'Repeat_Verify',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Input_Meta',
          label: 'Input_Meta',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Column_Meta',
          label: 'Column_Meta',
          input: input.Input
        }, {
          name: 'zxnz_table_Field_Form_Meta',
          label: 'Form_Meta',
          input: input.Input
        }, {
          name: 'zxnz_Note',
          label: 'Note',
          input: input.Input
        }],
        hiddens: {
          table_uuid: this.props.zxnz_UUID
        },
        merge: "values",
        submitApi: {
          method: "post",
          url: '/zxnz.core.base/define.table/createField'
        },
        onSubmitSuccess: function onSubmitSuccess(data, form) {
          _dialog.close();

          popup.notifier.success('创建成功!');

          _this._table.refresh();
        },
        onSubmitError: function onSubmitError(xhr) {
          _dialog.close();

          popup.notifier.error("创建失败：" + xhr.message);
        },
        buttons: [{
          value: 'Create',
          icon: 'faEdit',
          focus: true,
          type: 'submit'
        }]
      })
    });
  },
  __trashField: function __trashField() {
    if (!this.state.checkedFields.length) {
      return alert('请选择字段'), false;
    }

    popup.confirm('确定删除"' + this.state.checkedFields.length + '项"数据吗？', '警告', function () {
      popup.loader.loading('Deleteing ... ');
      zn.data["delete"]('/zxnz.core.base/define.table/deleteFields', {
        params: {
          field_ids: this.state.checkedFields.join(',')
        }
      }).then(function (response) {
        this._table.refresh();

        popup.notifier.success('删除成功!');
        popup.loader.close();
      }.bind(this))["catch"](function (err) {
        popup.notifier.error("删除失败：" + err.message);
        popup.loader.close();
      });
    }.bind(this), null, {
      cancel: '取消',
      confirm: '确定'
    });
  },
  __refresh: function __refresh() {
    this._table.refresh();
  },
  __onTableCheckboxChange: function __onTableCheckboxChange(checks, table) {
    this.state.checkedFields = checks.map(function (check) {
      return check.zxnz_ID;
    });
  },
  render: function render() {
    var _this2 = this;

    return /*#__PURE__*/React.createElement("div", {
      className: "zxnz-core-base-DefineTableStructure"
    }, /*#__PURE__*/React.createElement(layout.FixedLayout, {
      begin: 0,
      end: 50,
      body: /*#__PURE__*/React.createElement(table.Table, {
        ref: function ref(table) {
          return _this2._table = table;
        },
        checkbox: true,
        className: "zr-table-class-normal",
        cellPadding: 10,
        onCheckboxChange: this.__onTableCheckboxChange,
        columns: [{
          name: 'zxnz_Label',
          label: 'Label'
        }, {
          name: 'zxnz_table_Field_Name',
          label: 'Name'
        }, {
          name: 'zxnz_table_Field_Type',
          label: 'Type'
        }, {
          name: 'zxnz_table_Field_Length',
          label: 'Length'
        }, {
          name: 'zxnz_table_Field_Unsigned',
          label: 'Unsigned'
        }, {
          name: 'zxnz_table_Field_Zerofill',
          label: 'Zerofill'
        }, {
          name: 'zxnz_table_Field_Binary',
          label: 'Binary'
        }, {
          name: 'zxnz_table_Field_Allow_Null',
          label: 'Allow_Null'
        }, {
          name: 'zxnz_table_Field_Key',
          label: 'Key'
        }, {
          name: 'zxnz_table_Field_Default',
          label: 'Default'
        }, {
          name: 'zxnz_table_Field_Extra',
          label: 'Extra'
        }, {
          name: 'zxnz_table_Field_Encoding',
          label: 'Encoding'
        }, {
          name: 'zxnz_table_Field_Collation',
          label: 'Collation'
        }, {
          name: 'zxnz_table_Field_Comment',
          label: 'Comment'
        }, {
          name: 'zxnz_table_Field_Order',
          label: 'Order'
        }, {
          name: 'zxnz_table_Field_Generated',
          label: 'Generated'
        }, {
          name: 'zxnz_table_Field_Convert',
          label: 'Convert'
        }, {
          name: 'zxnz_table_Field_Hidden',
          label: 'Hidden'
        }, {
          name: 'zxnz_table_Field_Repeat_Verify',
          label: 'Repeat_Verify'
        }, {
          name: 'zxnz_table_Field_Input_Meta',
          label: 'Input_Meta'
        }, {
          name: 'zxnz_table_Field_Column_Meta',
          label: 'Column_Meta'
        }, {
          name: 'zxnz_table_Field_Form_Meta',
          label: 'Form_Meta'
        }],
        thead: {
          filter: true
        },
        fixed: true,
        tbody: {
          data: {
            method: 'get',
            url: '/zxnz.core.base/define.table/getFields?table_uuid=' + this.props.zxnz_UUID
          }
        }
      }),
      foot: /*#__PURE__*/React.createElement(button.Buttons, {
        onClick: this.__onToolBarClick,
        data: [{
          value: '创建字段',
          icon: 'faPlus',
          onClick: this.__createField
        }, {
          value: '删除字段',
          icon: 'faTrash',
          status: 'danger',
          onClick: this.__trashField
        }, {
          value: '刷新',
          icon: 'faCircleNotch',
          onClick: this.__refresh
        }]
      })
    }));
  }
});