"use strict";

var React = znui.React || require('react');

var layout = require('znui-react-layout');

var list = require('znui-react-list');

var button = require('znui-react-button');

var popup = require('znui-react-popup');

var form = require('znui-react-form');

var input = require('znui-react-input');

var selector = require('znui-react-selector');

var DefineTable = require('./DefineTable.js');

module.exports = React.createClass({
  displayName: 'DefineTables',
  getInitialState: function getInitialState() {
    return {
      table: null
    };
  },
  __createTable: function __createTable() {
    var _this = this;

    var _dialog = popup.dialog({
      title: 'Create Table',
      closeable: true,
      focus: false,
      content: /*#__PURE__*/React.createElement(form.AjaxForm, {
        data: [{
          name: 'zxnz_Label',
          label: 'Label',
          input: input.Input,
          required: true
        }, {
          name: 'zxnz_table_Name',
          label: 'TableName',
          input: input.Input,
          required: true
        }, {
          name: 'zxnz_table_Mixins',
          label: 'Mixins',
          input: input.Input
        }, {
          name: 'zxnz_table_Importable',
          label: 'Importable',
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Exportable',
          label: 'Exportable',
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Inputable',
          label: 'Inputable',
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }, {
          name: 'zxnz_table_Outputable',
          label: 'Outputable',
          input: selector.Radio,
          data: [{
            text: 'No',
            value: 0
          }, {
            text: 'Yes',
            value: 1
          }]
        }],
        hiddens: {
          zxnz_table_ID: this.props.zxnz_ID
        },
        submitApi: {
          method: "post",
          url: '/zxnz.core.base/define.table/createTable'
        },
        onSubmitSuccess: function onSubmitSuccess(data, form) {
          _dialog.close();

          popup.notifier.success('创建成功!');

          _this._table.refresh();
        },
        onSubmitError: function onSubmitError(xhr) {
          _dialog.close();

          popup.notifier.error("创建失败：" + xhr.message);
        },
        buttons: [{
          value: 'Create Table',
          icon: 'faEdit',
          focus: true,
          type: 'submit'
        }]
      })
    });
  },
  __generateTable: function __generateTable(item, index) {
    var _table = this._table;
    popup.confirm('一键生成将重置表结构和数据,确定操作吗？', '警告', function () {
      popup.loader.loading('Loading ... ');
      zn.data.get('/zxnz.core.base/define.table/buildTable', {
        params: {
          table_uuid: item.zxnz_UUID
        }
      }).then(function (response) {
        if (response.data.code == 200) {
          _table.refresh();

          popup.notifier.success('生成成功!');
        } else {
          popup.notifier.error("生成失败：" + response.data.result);
        }

        popup.loader.close();
      }, function () {
        popup.notifier.error("生成失败：" + err.message);
        popup.loader.close();
      })["catch"](function (err) {
        popup.notifier.error("生成失败：" + err.message);
        popup.loader.close();
      });
    }.bind(this), null, {
      cancel: '取消',
      confirm: '确定'
    });
  },
  __deleteTable: function __deleteTable(item, index) {
    var _table = this._table;
    popup.confirm('确定删除该表吗？', '警告', function () {
      popup.loader.loading('Deleteing ... ');
      zn.data["delete"]('/zxnz.core.base/define.table/deleteTable', {
        params: {
          table_uuid: item.zxnz_UUID
        }
      }).then(function (response) {
        _table.refresh();

        popup.notifier.success('删除成功!');
        popup.loader.close();
      })["catch"](function (err) {
        popup.notifier.error("删除失败：" + err.message);
        popup.loader.close();
      });
    }.bind(this), null, {
      cancel: '取消',
      confirm: '确定'
    });
  },
  __tableItemRender: function __tableItemRender(item, index) {
    var _this2 = this;

    return /*#__PURE__*/React.createElement("div", {
      className: "table-item"
    }, /*#__PURE__*/React.createElement("div", {
      className: "left"
    }, /*#__PURE__*/React.createElement("span", {
      className: "name"
    }, item.zxnz_Label)), /*#__PURE__*/React.createElement("div", {
      className: "right"
    }, !!item.zxnz_table_Generated ? /*#__PURE__*/React.createElement("span", {
      className: "tag"
    }, "\u5DF2\u751F\u6210") : /*#__PURE__*/React.createElement("span", {
      onClick: function onClick() {
        return _this2.__generateTable(item, index);
      },
      className: "btn"
    }, "\u4E00\u952E\u751F\u6210"), /*#__PURE__*/React.createElement("span", {
      onClick: function onClick() {
        return _this2.__deleteTable(item, index);
      },
      className: "btn"
    }, "\u5220\u9664")));
  },
  __head: function __head() {
    var _this3 = this;

    return /*#__PURE__*/React.createElement(layout.FixedLayout, {
      className: "DefineTables-left",
      begin: 50,
      end: 0,
      head: /*#__PURE__*/React.createElement("div", {
        className: "table-head"
      }, /*#__PURE__*/React.createElement("span", null, "Define Tables"), /*#__PURE__*/React.createElement(button.Button, {
        onClick: this.__createTable,
        label: "Create",
        icon: "faPlus"
      })),
      body: /*#__PURE__*/React.createElement(list.List, {
        className: "zr-list-style-flex-column",
        data: {
          method: 'get',
          url: '/zxnz.core.base/define.table/getTables'
        },
        itemRender: this.__tableItemRender,
        onDataCreated: function onDataCreated(data) {
          return _this3._table = data;
        },
        onItemClick: function onItemClick(event) {
          return _this3.setState({
            table: event.data
          });
        },
        selectMode: "single",
        textKey: "{zxnz_Label}({zxnz_table_Name})",
        valueKey: "zxnz_ID"
      })
    });
  },
  __foot: function __foot() {
    if (this.state.table) {
      return /*#__PURE__*/React.createElement(DefineTable, this.state.table);
    }

    return /*#__PURE__*/React.createElement("div", null, "Empty.");
  },
  render: function render() {
    return /*#__PURE__*/React.createElement(layout.ActivityLayout, {
      className: "zxnz-core-base-DefineTables",
      minX: 260,
      begin: 300,
      head: this.__head,
      foot: this.__foot
    });
  }
});