"use strict";

var React = znui.React || require('react');

var tree = require('znui-react-tree');

var button = require('znui-react-button');

var layout = require('znui-react-layout');

var popup = require('znui-react-popup');

var form = require('znui-react-form');

var input = require('znui-react-input');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    return {
      currentItem: null,
      currentTree: null
    };
  },
  __onTreeItemClick: function __onTreeItemClick(event, owner, item, index, tree) {
    var _data = zn.deepAssign({}, tree.props.data);

    _data.params.pid = item.zxnz_ID;
    tree.setState({
      data: _data
    });
    this.setState({
      currentItem: item,
      currentTree: tree
    });
  },
  __renderFoot: function __renderFoot() {},
  __addNode: function __addNode() {
    var _this = this;

    if (!this.state.currentItem) {
      return alert('请先选择'), false;
    }

    var _dialog = popup.dialog({
      title: 'Create Node',
      closeable: true,
      focus: false,
      content: /*#__PURE__*/React.createElement(form.AjaxForm, {
        data: [{
          name: 'zxnz_Label',
          label: 'Label',
          input: input.Input
        }],
        merge: "values",
        submitApi: {
          method: "post",
          url: '/zxnz.core.base/model.tree/addNodeByPid',
          data: {
            model: this.props.model,
            pid: this.state.currentItem.zxnz_ID || 0
          }
        },
        onSubmited: function onSubmited(response, form) {
          var _data = response.data;

          if (_data.code == 200) {
            _this.state.currentTree.refreshChild();

            popup.notifier.success('创建成功!');
          } else {
            popup.notifier.error("创建失败：" + _data.message);
          }

          _dialog.close();
        },
        onSubmitError: function onSubmitError(xhr) {
          _dialog.close();

          popup.notifier.error("创建失败：" + xhr.message);
        },
        buttons: [{
          value: 'Create',
          icon: 'faEdit',
          focus: true,
          type: 'submit'
        }]
      })
    });
  },
  __trashNode: function __trashNode() {
    if (!this.state.currentItem) {
      return alert('请先选择'), false;
    }

    var _tree = this.state.currentTree;
    popup.confirm('确定删除该项吗？', '警告', function () {
      popup.loader.loading('Deleteing ... ');
      zn.data["delete"]('/zxnz.core.base/model.tree/deleteAllChildByPid', {
        params: {
          model: this.props.model,
          pid: this.state.currentItem.zxnz_ID || 0
        }
      }).then(function (response) {
        _tree.refresh();

        _tree.refreshChild();

        popup.notifier.success('删除成功!');
        popup.loader.close();
      })["catch"](function (err) {
        popup.notifier.error("删除失败：" + err.message);
        popup.loader.close();
      });
    }.bind(this), null, {
      cancel: '取消',
      confirm: '确定'
    });
  },
  __updateNode: function __updateNode() {
    var _this2 = this;

    if (!this.state.currentItem) {
      return alert('请先选择'), false;
    }

    var _dialog = popup.dialog({
      title: 'Edit Node',
      closeable: true,
      focus: false,
      content: /*#__PURE__*/React.createElement(form.AjaxForm, {
        data: [{
          name: 'zxnz_Label',
          label: 'Label',
          input: input.Input,
          value: this.state.currentItem.zxnz_Label
        }],
        merge: "updates",
        submitApi: {
          method: "post",
          url: '/zxnz.core.base/model.base/updateById',
          data: {
            model: this.props.model,
            id: this.state.currentItem.zxnz_ID || 0
          }
        },
        onSubmited: function onSubmited(response, form) {
          var _data = response.data;

          if (_data.code == 200) {
            _this2.state.currentTree.refresh();

            popup.notifier.success('修改成功!');
          } else {
            popup.notifier.error("修改失败：" + _data.message);
          }

          _dialog.close();
        },
        onSubmitError: function onSubmitError(xhr) {
          _dialog.close();

          popup.notifier.error("修改失败：" + xhr.message);
        },
        buttons: [{
          value: 'Edit',
          icon: 'faEdit',
          focus: true,
          type: 'submit'
        }]
      })
    });
  },
  __upNode: function __upNode() {
    if (!this.state.currentItem) {
      return alert('请先选择'), false;
    }

    var _tree = this.state.currentTree;
    popup.loader.loading('上移中 ... ');
    zn.data.post('/zxnz.core.base/model.tree/orderNode', {
      data: {
        model: this.props.model,
        id: this.state.currentItem.zxnz_ID || 0,
        order: 'up'
      }
    }).then(function (response) {
      _tree.refresh();

      popup.notifier.success('上移成功!');
      popup.loader.close();
    })["catch"](function (err) {
      popup.notifier.error("上移失败：" + err.message);
      popup.loader.close();
    });
  },
  __downNode: function __downNode() {
    if (!this.state.currentItem) {
      return alert('请先选择'), false;
    }

    var _tree = this.state.currentTree;
    popup.loader.loading('上移中 ... ');
    zn.data.post('/zxnz.core.base/model.tree/orderNode', {
      data: {
        model: this.props.model,
        id: this.state.currentItem.zxnz_ID || 0,
        order: 'down'
      }
    }).then(function (response) {
      _tree.refresh();

      popup.notifier.success('下移成功!');
      popup.loader.close();
    })["catch"](function (err) {
      popup.notifier.error("下移失败：" + err.message);
      popup.loader.close();
    });
  },
  __exchangeNode: function __exchangeNode() {
    var _this3 = this;

    if (!this.state.currentItem) {
      return alert('请先选择'), false;
    }

    var _dialog = popup.dialog({
      title: 'Remove Node',
      closeable: true,
      focus: false,
      content: /*#__PURE__*/React.createElement(form.AjaxForm, {
        data: [{
          name: 'target',
          label: '父节点ID',
          input: input.Input
        }],
        submitApi: {
          method: "post",
          url: '/zxnz.core.base/model.tree/moveNode',
          data: {
            model: this.props.model,
            source: this.state.currentItem.zxnz_ID || 0
          }
        },
        onSubmited: function onSubmited(response, form) {
          var _data = response.data;

          if (_data.code == 200) {
            _this3.state.currentTree.refreshChild();

            popup.notifier.success('移动成功!');
          } else {
            popup.notifier.error("移动失败：" + _data.message);
          }

          _dialog.close();
        },
        onSubmitError: function onSubmitError(xhr) {
          _dialog.close();

          popup.notifier.error("移动失败：" + xhr.message);
        },
        buttons: [{
          value: 'Remove',
          icon: 'faExchangeAlt',
          focus: true,
          type: 'submit'
        }]
      })
    });
  },
  __itemLabelRender: function __itemLabelRender() {},
  render: function render() {
    var _this4 = this;

    return /*#__PURE__*/React.createElement(layout.FixedLayout, {
      className: znui.react.classname("zxnz-core-base-Tree-Model-Data-Editor", this.props.className),
      style: this.props.style,
      begin: 40,
      end: 40,
      head: function head() {
        return /*#__PURE__*/React.createElement(button.Buttons, {
          data: [{
            value: '添加',
            icon: 'faPlus',
            onClick: _this4.__addNode
          }, {
            value: '删除',
            icon: 'faTrash',
            onClick: _this4.__trashNode
          }, {
            value: '修改',
            icon: 'faEdit',
            onClick: _this4.__updateNode
          }, {
            value: '上移',
            icon: 'faSortAmountUpAlt',
            onClick: _this4.__upNode
          }, {
            value: '下移',
            icon: 'faSortAmountDownAlt',
            onClick: _this4.__downNode
          }, {
            value: '移动',
            icon: 'faExchangeAlt',
            onClick: _this4.__exchangeNode
          }]
        });
      },
      body: /*#__PURE__*/React.createElement(tree.AccordionTree, {
        labelKey: "{zxnz_ID}\u3001{zxnz_Label} ({zxnz_tree_Son_Count})",
        itemKey: "zxnz_ID",
        itemLabelRender: this.__itemLabelRender,
        data: {
          method: "get",
          url: '/zxnz.core.base/model.tree/getChildByPid',
          params: {
            model: this.props.model,
            pid: this.props.pid || 0
          }
        },
        responseHandler: function responseHandler(response) {
          return response.data.result;
        },
        onItemClick: this.__onTreeItemClick
      }),
      foot: this.__renderFoot
    });
  }
});